package com.sg.answer.sg;

import com.sg.answer.core.HttpRequestConfig;
import com.sg.answer.core.HttpRequestResult;
import com.sg.answer.core.SgEntity;
import com.sg.answer.core.UserInfoEntity;
import com.sg.answer.utils.HttpClientUtils;
import com.sg.answer.utils.Md5Utils;
import com.sg.answer.utils.ObjectUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.client.CookieStore;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.protocol.HttpContext;

import javax.swing.*;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;

import static com.sg.answer.sg.Constant.*;

/**
 * @author 王玉鹏
 * @version 1.0
 * @className API
 * @description TODO
 * @date 2020/3/19 13:07
 */
@Slf4j
public class API {
    //登陆
    public  static CookieStore login(String username, String password) throws Exception {
        Map<String, String> map = new HashMap<>();
        map.put("username",username);
        map.put("password", Md5Utils.encryptPassword(username,password));
        CookieStore cookie = SgController.doPost(API+"users/chklogin", map, "UTF-8");
        if (ObjectUtils.isEmpty(cookie)|| cookie.getCookies().size()<=1){
            log.info("cookie为空,登陆失败");
            throw new SgException(ErrorCode.PASSWORD_ERROR.getCode(),ErrorCode.PASSWORD_ERROR.getName());
        }
        return cookie;
    }
    //获取个人信息
/*    public  static  void getPersonalInfo(CookieStore cookie, SgEntity sgEntity, UserInfoEntity userInfoEntity) throws Exception {

        HttpContext httpContext = new HttpClientContext();
        ((HttpClientContext) httpContext).setCookieStore(cookie);
        HttpRequestConfig config = HttpRequestConfig.create().url(API+"/personal").context(httpContext);
        HttpRequestResult result = HttpClientUtils.post(config);
        String data=result.getResponseText();

        Matcher m = userNamePattern.matcher(data);

        Matcher n = jobPattern.matcher(data);
        while(m.find()) {
            userInfoEntity .getUserNameData().setText(m.group().replaceAll("<li>","").replaceAll("</li>","").replaceAll("姓名：","").replaceAll("<span>","").replaceAll("</span>","").trim());
        }
        while(n.find()) {
            userInfoEntity.getJobTypeData().setText(n.group().replaceAll("<li>","").replaceAll("</li>","").replaceAll("职务：","").replaceAll("<span>","").replaceAll("</span>","").trim());
        }
        userInfoEntity.getJobNoData().setText(sgEntity.getUserText().getText());

        Matcher m2=userInfoPattern.matcher(data);
        int a = 0;
        while(m2.find()) {
            if (a==0){
                //积分
                userInfoEntity.getIntegralDate().setText(m2.group().replaceAll("<strong>","").replaceAll("</strong>","").trim());
            }
            if (a==1){
                //金币
                userInfoEntity.getGoldCoinData().setText(m2.group().replaceAll("<strong>","").replaceAll("</strong>","").trim());
            }
            if (a==2){
                //钻石
                userInfoEntity.getDiamondData().setText(m2.group().replaceAll("<strong>","").replaceAll("</strong>","").trim());
            }
            a++;
        }

        //获取用户头像
        Matcher m3=imagePattern.matcher(data);
        String src="";
        while(m3.find()) {
            src=m3.group(2);
            log.info("当前用户头像：{}",src);
        }
        URL url = new URL(Constant.SERVER_IP+src);
        sgEntity.getImage().setIcon(new ImageIcon(url));
    }

    public  static int getCurrentLevel(CookieStore cookie, SgEntity sgEntity) throws Exception {
        HttpContext httpContext = new HttpClientContext();
        ((HttpClientContext) httpContext).setCookieStore(cookie);

        HttpRequestConfig config = HttpRequestConfig.create().url(API+"/cglb/gk?id="+sgEntity.getId()+"&passtype="+sgEntity.getType()).context(httpContext);
//        http://117.39.28.234:8023/index/cglb/gk?id=1&passtype=3
        HttpRequestResult result = HttpClientUtils.post(config);

        String scjl=result.getResponseText();
        Matcher m=passPattern.matcher(scjl);
        String bq="";
        while(m.find()) {
            bq=m.group(1);
        }
        Matcher m2=countDownPattern.matcher(scjl);
        while(m2.find()) {
            sgEntity.getTimeLabel().setText(m2.group().replaceAll("<p>","").replaceAll("</p>","").trim());
        }
        //当前用户答题关数
        int gs =1;
        for (int i = 0; i < bq.split("<i>").length; i++) {
            if (i==1){
                gs= Integer.valueOf(bq.split("<i>")[i].replaceAll("[^0-9]", ""));
            }
        }
        return gs;
    }*/

    public  static void reset(JButton loginButton,SgEntity sgEntity,String msg){
        sgEntity.getTextArea().setText(msg+"\t");
        sgEntity.getTextArea().paintImmediately( sgEntity.getTextArea().getBounds());
        loginButton.setEnabled(true);
        loginButton.setText("登陆答题");
        sgEntity.setCoustomScore(0.0);
        sgEntity.getCoustomText().setText("自定义刷分");
        sgEntity.getXjText().setText("0");
        sgEntity.getMbText().setText("∞");
    }
}
