package com.sg.answer.utils;

import com.sg.answer.core.HttpRequestConfig;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.client.CookieStore;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.protocol.HttpContext;

@Slf4j
public class SgUtils {
    public static String executeRemotePostRequest(CookieStore cookie, String url) throws Exception {
        log.info("请求url:{}", url);
        HttpContext context = createHttpContext(cookie);
        HttpRequestConfig config = HttpRequestConfig.create()
                .url(url)
                .context(context);

        return HttpClientUtils.post(config).getResponseText();
    }

    private static HttpContext createHttpContext(CookieStore cookieStore) {
        HttpClientContext context = new HttpClientContext();
        context.setCookieStore(cookieStore);
        return context;
    }
}
